#line 1 "D:/Proekti/Frequency Meter 50MHz/FrequencyMeter.c"
#line 1 "d:/proekti/frequency meter 50mhz/ar2r.h"

void Ar2rSplash(void);
unsigned short BCDMask(unsigned short num);
unsigned short Days(unsigned short mon, unsigned int ye);
unsigned short IsLeapYear(unsigned int yea);
unsigned ConTemp(unsigned temp);
unsigned short dstm(unsigned int mye);
unsigned short dsto(unsigned int yeo);
#line 21 "D:/Proekti/Frequency Meter 50MHz/FrequencyMeter.c"
unsigned long cntr, freq=0;
unsigned char str[10];
unsigned short state;

void Count(void)
{
 freq=(TMR1H<<8)+TMR1L;
 freq=(cntr*65536)+freq;
}

void ResetClk(void)
{
 PORTD.F0 = 1;
 PORTD.F0 = 0;
}

void interrupt(void)
{
 if(INTCON.INTF)
 {
 state=1;
 INTCON.INTF = 0;
 }
 if(PIR1.TMR1IF)
 {
 cntr++ ;
 PIR1.TMR1IF = 0 ;
 }
}

void main()
{
 Lcd_Init(&PORTB);
 TRISB.F0 = 1;
 TRISC.F0 = 1;
 TRISD.F0 = 0;
 OPTION_REG = 0b11000000;
 T1CON = 0b00000111;

 Lcd_Cmd(LCD_CURSOR_OFF);
 Ar2rSplash();
 LCD_Cmd(LCD_CLEAR);

 PIE1 = 0b00000001;
 INTCON = 0b11010000;
 ResetClk();

 while (1)
 {
 if(state==1)
 {
 INTCON.GIE = 0;
 PIE1 = 0;

 Count();
 Lcd_Out(1,4, "Frequency");
 LongToStr(freq, str);
 Lcd_Out(2,1, str);
 Lcd_Chr_CP(' ');
 Lcd_Chr_CP('H');
 Lcd_Chr_CP('z');

 cntr = 0;
 TMR1H= 0;
 TMR1L= 0;
 state=0;

 PIE1 = 0b00000001;
 INTCON = 0b11010000;

 ResetClk();
 }
 }
}
